Location via proxy:   [ UP ]  
[Report a bug]   [Manage cookies]                
Skip to content
Primary navigation

Compact a response

POST/responses/compact

Compact a conversation. Returns a compacted response object.

Learn when and how to compact long-running conversations in the conversation state guide. For ZDR-compatible compaction details, see Compaction (advanced).

Body ParametersJSONExpand Collapse
model: "gpt-5.4" or "gpt-5.3-chat-latest" or "gpt-5.2" or 85 more or string

Model ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.

Accepts one of the following:
UnionMember0 = "gpt-5.4" or "gpt-5.3-chat-latest" or "gpt-5.2" or 85 more

Model ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.

Accepts one of the following:
"gpt-5.4"
"gpt-5.3-chat-latest"
"gpt-5.2"
"gpt-5.2-2025-12-11"
"gpt-5.2-chat-latest"
"gpt-5.2-pro"
"gpt-5.2-pro-2025-12-11"
"gpt-5.1"
"gpt-5.1-2025-11-13"
"gpt-5.1-codex"
"gpt-5.1-mini"
"gpt-5.1-chat-latest"
"gpt-5"
"gpt-5-mini"
"gpt-5-nano"
"gpt-5-2025-08-07"
"gpt-5-mini-2025-08-07"
"gpt-5-nano-2025-08-07"
"gpt-5-chat-latest"
"gpt-4.1"
"gpt-4.1-mini"
"gpt-4.1-nano"
"gpt-4.1-2025-04-14"
"gpt-4.1-mini-2025-04-14"
"gpt-4.1-nano-2025-04-14"
"o4-mini"
"o4-mini-2025-04-16"
"o3"
"o3-2025-04-16"
"o3-mini"
"o3-mini-2025-01-31"
"o1"
"o1-2024-12-17"
"o1-preview"
"o1-preview-2024-09-12"
"o1-mini"
"o1-mini-2024-09-12"
"gpt-4o"
"gpt-4o-2024-11-20"
"gpt-4o-2024-08-06"
"gpt-4o-2024-05-13"
"gpt-4o-audio-preview"
"gpt-4o-audio-preview-2024-10-01"
"gpt-4o-audio-preview-2024-12-17"
"gpt-4o-audio-preview-2025-06-03"
"gpt-4o-mini-audio-preview"
"gpt-4o-mini-audio-preview-2024-12-17"
"gpt-4o-search-preview"
"gpt-4o-mini-search-preview"
"gpt-4o-search-preview-2025-03-11"
"gpt-4o-mini-search-preview-2025-03-11"
"chatgpt-4o-latest"
"codex-mini-latest"
"gpt-4o-mini"
"gpt-4o-mini-2024-07-18"
"gpt-4-turbo"
"gpt-4-turbo-2024-04-09"
"gpt-4-0125-preview"
"gpt-4-turbo-preview"
"gpt-4-1106-preview"
"gpt-4-vision-preview"
"gpt-4"
"gpt-4-0314"
"gpt-4-0613"
"gpt-4-32k"
"gpt-4-32k-0314"
"gpt-4-32k-0613"
"gpt-3.5-turbo"
"gpt-3.5-turbo-16k"
"gpt-3.5-turbo-0301"
"gpt-3.5-turbo-0613"
"gpt-3.5-turbo-1106"
"gpt-3.5-turbo-0125"
"gpt-3.5-turbo-16k-0613"
"o1-pro"
"o1-pro-2025-03-19"
"o3-pro"
"o3-pro-2025-06-10"
"o3-deep-research"
"o3-deep-research-2025-06-26"
"o4-mini-deep-research"
"o4-mini-deep-research-2025-06-26"
"computer-use-preview"
"computer-use-preview-2025-03-11"
"gpt-5-codex"
"gpt-5-pro"
"gpt-5-pro-2025-10-06"
"gpt-5.1-codex-max"
UnionMember1 = string
input: optional string or array of EasyInputMessage { content, role, phase, type } or object { content, role, status, type } or ResponseOutputMessage { id, content, role, 3 more } or 25 more

Text, image, or file inputs to the model, used to generate a response

Accepts one of the following:
UnionMember0 = string

A text input to the model, equivalent to a text input with the user role.

UnionMember1 = array of EasyInputMessage { content, role, phase, type } or object { content, role, status, type } or ResponseOutputMessage { id, content, role, 3 more } or 25 more

A list of one or many input items to the model, containing different content types.

Accepts one of the following:
EasyInputMessage = object { content, role, phase, type }

A message input to the model with a role indicating instruction following hierarchy. Instructions given with the developer or system role take precedence over instructions given with the user role. Messages with the assistant role are presumed to have been generated by the model in previous interactions.

content: string or ResponseInputMessageContentList { , , }

Text, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.

Accepts one of the following:
TextInput = string

A text input to the model.

ResponseInputMessageContentList = array of ResponseInputContent

A list of one or many input items to the model, containing different content types.

Accepts one of the following:
ResponseInputText = object { text, type }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

ResponseInputImage = object { detail, type, file_id, image_url }

An image input to the model. Learn about image inputs.

detail: "low" or "high" or "auto" or "original"

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id: optional string

The ID of the file to be sent to the model.

image_url: optional string

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

ResponseInputFile = object { type, detail, file_data, 3 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail: optional "low" or "high"

The detail level of the file to be sent to the model. One of high or low. Defaults to high.

Accepts one of the following:
"low"
"high"
file_data: optional string

The content of the file to be sent to the model.

file_id: optional string

The ID of the file to be sent to the model.

file_url: optional string

The URL of the file to be sent to the model.

filename: optional string

The name of the file to be sent to the model.

role: "user" or "assistant" or "system" or "developer"

The role of the message input. One of user, assistant, system, or developer.

Accepts one of the following:
"user"
"assistant"
"system"
"developer"
phase: optional "commentary" or "final_answer"

Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.

Accepts one of the following:
"commentary"
"final_answer"
type: optional "message"

The type of the message input. Always message.

Message = object { content, role, status, type }

A message input to the model with a role indicating instruction following hierarchy. Instructions given with the developer or system role take precedence over instructions given with the user role.

A list of one or many input items to the model, containing different content types.

Accepts one of the following:
ResponseInputText = object { text, type }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

ResponseInputImage = object { detail, type, file_id, image_url }

An image input to the model. Learn about image inputs.

detail: "low" or "high" or "auto" or "original"

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id: optional string

The ID of the file to be sent to the model.

image_url: optional string

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

ResponseInputFile = object { type, detail, file_data, 3 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail: optional "low" or "high"

The detail level of the file to be sent to the model. One of high or low. Defaults to high.

Accepts one of the following:
"low"
"high"
file_data: optional string

The content of the file to be sent to the model.

file_id: optional string

The ID of the file to be sent to the model.

file_url: optional string

The URL of the file to be sent to the model.

filename: optional string

The name of the file to be sent to the model.

role: "user" or "system" or "developer"

The role of the message input. One of user, system, or developer.

Accepts one of the following:
"user"
"system"
"developer"
status: optional "in_progress" or "completed" or "incomplete"

The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: optional "message"

The type of the message input. Always set to message.

ResponseOutputMessage = object { id, content, role, 3 more }

An output message from the model.

id: string

The unique ID of the output message.

content: array of ResponseOutputText { annotations, logprobs, text, type } or ResponseOutputRefusal { refusal, type }

The content of the output message.

Accepts one of the following:
ResponseOutputText = object { annotations, logprobs, text, type }

A text output from the model.

annotations: array of object { file_id, filename, index, type } or object { end_index, start_index, title, 2 more } or object { container_id, end_index, file_id, 3 more } or object { file_id, index, type }

The annotations of the text output.

Accepts one of the following:
FileCitation = object { file_id, filename, index, type }

A citation to a file.

file_id: string

The ID of the file.

filename: string

The filename of the file cited.

index: number

The index of the file in the list of files.

type: "file_citation"

The type of the file citation. Always file_citation.

URLCitation = object { end_index, start_index, title, 2 more }

A citation for a web resource used to generate a model response.

end_index: number

The index of the last character of the URL citation in the message.

start_index: number

The index of the first character of the URL citation in the message.

title: string

The title of the web resource.

type: "url_citation"

The type of the URL citation. Always url_citation.

url: string

The URL of the web resource.

ContainerFileCitation = object { container_id, end_index, file_id, 3 more }

A citation for a container file used to generate a model response.

container_id: string

The ID of the container file.

end_index: number

The index of the last character of the container file citation in the message.

file_id: string

The ID of the file.

filename: string

The filename of the container file cited.

start_index: number

The index of the first character of the container file citation in the message.

type: "container_file_citation"

The type of the container file citation. Always container_file_citation.

FilePath = object { file_id, index, type }

A path to a file.

file_id: string

The ID of the file.

index: number

The index of the file in the list of files.

type: "file_path"

The type of the file path. Always file_path.

logprobs: array of object { token, bytes, logprob, top_logprobs }
token: string
bytes: array of number
logprob: number
top_logprobs: array of object { token, bytes, logprob }
token: string
bytes: array of number
logprob: number
text: string

The text output from the model.

type: "output_text"

The type of the output text. Always output_text.

ResponseOutputRefusal = object { refusal, type }

A refusal from the model.

refusal: string

The refusal explanation from the model.

type: "refusal"

The type of the refusal. Always refusal.

role: "assistant"

The role of the output message. Always assistant.

status: "in_progress" or "completed" or "incomplete"

The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: "message"

The type of the output message. Always message.

phase: optional "commentary" or "final_answer"

Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer). For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.

Accepts one of the following:
"commentary"
"final_answer"
FileSearchCall = object { id, queries, status, 2 more }

The results of a file search tool call. See the file search guide for more information.

id: string

The unique ID of the file search tool call.

queries: array of string

The queries used to search for files.

status: "in_progress" or "searching" or "completed" or 2 more

The status of the file search tool call. One of in_progress, searching, incomplete or failed,

Accepts one of the following:
"in_progress"
"searching"
"completed"
"incomplete"
"failed"
type: "file_search_call"

The type of the file search tool call. Always file_search_call.

results: optional array of object { attributes, file_id, filename, 2 more }

The results of the file search tool call.

attributes: optional map[string or number or boolean]

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember2 = boolean
file_id: optional string

The unique ID of the file.

filename: optional string

The name of the file.

score: optional number

The relevance score of the file - a value between 0 and 1.

formatfloat
text: optional string

The text that was retrieved from the file.

ComputerCall = object { id, call_id, pending_safety_checks, 4 more }

A tool call to a computer use tool. See the computer use guide for more information.

id: string

The unique ID of the computer call.

call_id: string

An identifier used when responding to the tool call with output.

pending_safety_checks: array of object { id, code, message }

The pending safety checks for the computer call.

id: string

The ID of the pending safety check.

code: optional string

The type of the pending safety check.

message: optional string

Details about the pending safety check.

status: "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: "computer_call"

The type of the computer call. Always computer_call.

action: optional ComputerAction

A click action.

Accepts one of the following:
Click = object { button, type, x, y }

A click action.

button: "left" or "right" or "wheel" or 2 more

Indicates which mouse button was pressed during the click. One of left, right, wheel, back, or forward.

Accepts one of the following:
"left"
"right"
"wheel"
"back"
"forward"
type: "click"

Specifies the event type. For a click action, this property is always click.

x: number

The x-coordinate where the click occurred.

y: number

The y-coordinate where the click occurred.

DoubleClick = object { type, x, y }

A double click action.

type: "double_click"

Specifies the event type. For a double click action, this property is always set to double_click.

x: number

The x-coordinate where the double click occurred.

y: number

The y-coordinate where the double click occurred.

Drag = object { path, type }

A drag action.

path: array of object { x, y }

An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg

[
  { x: 100, y: 200 },
  { x: 200, y: 300 }
]
x: number

The x-coordinate.

y: number

The y-coordinate.

type: "drag"

Specifies the event type. For a drag action, this property is always set to drag.

Keypress = object { keys, type }

A collection of keypresses the model would like to perform.

keys: array of string

The combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key.

type: "keypress"

Specifies the event type. For a keypress action, this property is always set to keypress.

Move = object { type, x, y }

A mouse move action.

type: "move"

Specifies the event type. For a move action, this property is always set to move.

x: number

The x-coordinate to move to.

y: number

The y-coordinate to move to.

Screenshot = object { type }

A screenshot action.

type: "screenshot"

Specifies the event type. For a screenshot action, this property is always set to screenshot.

Scroll = object { scroll_x, scroll_y, type, 2 more }

A scroll action.

scroll_x: number

The horizontal scroll distance.

scroll_y: number

The vertical scroll distance.

type: "scroll"

Specifies the event type. For a scroll action, this property is always set to scroll.

x: number

The x-coordinate where the scroll occurred.

y: number

The y-coordinate where the scroll occurred.

Type = object { text, type }

An action to type in text.

text: string

The text to type.

type: "type"

Specifies the event type. For a type action, this property is always set to type.

Wait = object { type }

A wait action.

type: "wait"

Specifies the event type. For a wait action, this property is always set to wait.

actions: optional ComputerActionList { Click, DoubleClick, Drag, 6 more }

Flattened batched actions for computer_use. Each action includes an type discriminator and action-specific fields.

Accepts one of the following:
Click = object { button, type, x, y }

A click action.

button: "left" or "right" or "wheel" or 2 more

Indicates which mouse button was pressed during the click. One of left, right, wheel, back, or forward.

Accepts one of the following:
"left"
"right"
"wheel"
"back"
"forward"
type: "click"

Specifies the event type. For a click action, this property is always click.

x: number

The x-coordinate where the click occurred.

y: number

The y-coordinate where the click occurred.

DoubleClick = object { type, x, y }

A double click action.

type: "double_click"

Specifies the event type. For a double click action, this property is always set to double_click.

x: number

The x-coordinate where the double click occurred.

y: number

The y-coordinate where the double click occurred.

Drag = object { path, type }

A drag action.

path: array of object { x, y }

An array of coordinates representing the path of the drag action. Coordinates will appear as an array of objects, eg

[
  { x: 100, y: 200 },
  { x: 200, y: 300 }
]
x: number

The x-coordinate.

y: number

The y-coordinate.

type: "drag"

Specifies the event type. For a drag action, this property is always set to drag.

Keypress = object { keys, type }

A collection of keypresses the model would like to perform.

keys: array of string

The combination of keys the model is requesting to be pressed. This is an array of strings, each representing a key.

type: "keypress"

Specifies the event type. For a keypress action, this property is always set to keypress.

Move = object { type, x, y }

A mouse move action.

type: "move"

Specifies the event type. For a move action, this property is always set to move.

x: number

The x-coordinate to move to.

y: number

The y-coordinate to move to.

Screenshot = object { type }

A screenshot action.

type: "screenshot"

Specifies the event type. For a screenshot action, this property is always set to screenshot.

Scroll = object { scroll_x, scroll_y, type, 2 more }

A scroll action.

scroll_x: number

The horizontal scroll distance.

scroll_y: number

The vertical scroll distance.

type: "scroll"

Specifies the event type. For a scroll action, this property is always set to scroll.

x: number

The x-coordinate where the scroll occurred.

y: number

The y-coordinate where the scroll occurred.

Type = object { text, type }

An action to type in text.

text: string

The text to type.

type: "type"

Specifies the event type. For a type action, this property is always set to type.

Wait = object { type }

A wait action.

type: "wait"

Specifies the event type. For a wait action, this property is always set to wait.

ComputerCallOutput = object { call_id, output, type, 3 more }

The output of a computer tool call.

call_id: string

The ID of the computer tool call that produced the output.

maxLength64
minLength1
output: ResponseComputerToolCallOutputScreenshot { type, file_id, image_url }

A computer screenshot image used with the computer use tool.

type: "computer_screenshot"

Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.

file_id: optional string

The identifier of an uploaded file that contains the screenshot.

image_url: optional string

The URL of the screenshot image.

type: "computer_call_output"

The type of the computer tool call output. Always computer_call_output.

id: optional string

The ID of the computer tool call output.

acknowledged_safety_checks: optional array of object { id, code, message }

The safety checks reported by the API that have been acknowledged by the developer.

id: string

The ID of the pending safety check.

code: optional string

The type of the pending safety check.

message: optional string

Details about the pending safety check.

status: optional "in_progress" or "completed" or "incomplete"

The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
WebSearchCall = object { id, action, status, type }

The results of a web search tool call. See the web search guide for more information.

id: string

The unique ID of the web search tool call.

action: object { query, type, queries, sources } or object { type, url } or object { pattern, type, url }

An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page).

Accepts one of the following:
Search = object { query, type, queries, sources }

Action type "search" - Performs a web search query.

query: string

[DEPRECATED] The search query.

type: "search"

The action type.

queries: optional array of string

The search queries.

sources: optional array of object { type, url }

The sources used in the search.

type: "url"

The type of source. Always url.

url: string

The URL of the source.

OpenPage = object { type, url }

Action type "open_page" - Opens a specific URL from search results.

type: "open_page"

The action type.

url: optional string

The URL opened by the model.

formaturi
FindInPage = object { pattern, type, url }

Action type "find_in_page": Searches for a pattern within a loaded page.

pattern: string

The pattern or text to search for within the page.

type: "find_in_page"

The action type.

url: string

The URL of the page searched for the pattern.

formaturi
status: "in_progress" or "searching" or "completed" or "failed"

The status of the web search tool call.

Accepts one of the following:
"in_progress"
"searching"
"completed"
"failed"
type: "web_search_call"

The type of the web search tool call. Always web_search_call.

FunctionCall = object { arguments, call_id, name, 4 more }

A tool call to run a function. See the function calling guide for more information.

arguments: string

A JSON string of the arguments to pass to the function.

call_id: string

The unique ID of the function tool call generated by the model.

name: string

The name of the function to run.

type: "function_call"

The type of the function tool call. Always function_call.

id: optional string

The unique ID of the function tool call.

namespace: optional string

The namespace of the function to run.

status: optional "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
FunctionCallOutput = object { call_id, output, type, 2 more }

The output of a function tool call.

call_id: string

The unique ID of the function tool call generated by the model.

maxLength64
minLength1
output: string or array of ResponseInputTextContent { text, type } or ResponseInputImageContent { type, detail, file_id, image_url } or ResponseInputFileContent { type, detail, file_data, 3 more }

Text, image, or file output of the function tool call.

Accepts one of the following:
UnionMember0 = string

A JSON string of the output of the function tool call.

UnionMember1 = array of ResponseInputTextContent { text, type } or ResponseInputImageContent { type, detail, file_id, image_url } or ResponseInputFileContent { type, detail, file_data, 3 more }

An array of content outputs (text, image, file) for the function tool call.

Accepts one of the following:
ResponseInputTextContent = object { text, type }

A text input to the model.

text: string

The text input to the model.

maxLength10485760
type: "input_text"

The type of the input item. Always input_text.

ResponseInputImageContent = object { type, detail, file_id, image_url }

An image input to the model. Learn about image inputs

type: "input_image"

The type of the input item. Always input_image.

detail: optional "low" or "high" or "auto" or "original"

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
file_id: optional string

The ID of the file to be sent to the model.

image_url: optional string

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

maxLength20971520
ResponseInputFileContent = object { type, detail, file_data, 3 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail: optional "high" or "low"

The detail level of the file to be sent to the model. One of high or low. Defaults to high.

Accepts one of the following:
"high"
"low"
file_data: optional string

The base64-encoded data of the file to be sent to the model.

maxLength33554432
file_id: optional string

The ID of the file to be sent to the model.

file_url: optional string

The URL of the file to be sent to the model.

filename: optional string

The name of the file to be sent to the model.

type: "function_call_output"

The type of the function tool call output. Always function_call_output.

id: optional string

The unique ID of the function tool call output. Populated when this item is returned via API.

status: optional "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ToolSearchCall = object { arguments, type, id, 3 more }
arguments: unknown

The arguments supplied to the tool search call.

type: "tool_search_call"

The item type. Always tool_search_call.

id: optional string

The unique ID of this tool search call.

call_id: optional string

The unique ID of the tool search call generated by the model.

maxLength64
minLength1
execution: optional "server" or "client"

Whether tool search was executed by the server or by the client.

Accepts one of the following:
"server"
"client"
status: optional "in_progress" or "completed" or "incomplete"

The status of the tool search call.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ToolSearchOutput = object { tools, type, id, 3 more }
tools: array of object { name, parameters, strict, 3 more } or object { type, vector_store_ids, filters, 2 more } or object { type } or 12 more

The loaded tool definitions returned by the tool search output.

Accepts one of the following:
Function = object { name, parameters, strict, 3 more }

Defines a function in your own code the model can choose to call. Learn more about function calling.

name: string

The name of the function to call.

parameters: map[unknown]

A JSON schema object describing the parameters of the function.

strict: boolean

Whether to enforce strict parameter validation. Default true.

type: "function"

The type of the function tool. Always function.

defer_loading: optional boolean

Whether this function is deferred and loaded via tool search.

description: optional string

A description of the function. Used by the model to determine whether or not to call the function.

FileSearch = object { type, vector_store_ids, filters, 2 more }

A tool that searches for relevant content from uploaded files. Learn more about the file search tool.

type: "file_search"

The type of the file search tool. Always file_search.

vector_store_ids: array of string

The IDs of the vector stores to search.

filters: optional ComparisonFilter { key, type, value } or CompoundFilter { filters, type }

A filter to apply.

Accepts one of the following:
ComparisonFilter = object { key, type, value }

A filter used to compare a specified attribute key to a given value using a defined comparison operation.

key: string

The key to compare against the value.

type: "eq" or "ne" or "gt" or 3 more

Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.

  • eq: equals
  • ne: not equal
  • gt: greater than
  • gte: greater than or equal
  • lt: less than
  • lte: less than or equal
  • in: in
  • nin: not in
Accepts one of the following:
"eq"
"ne"
"gt"
"gte"
"lt"
"lte"
value: string or number or boolean or array of string or number

The value to compare against the attribute key; supports string, number, or boolean types.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember2 = boolean
UnionMember3 = array of string or number
Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
CompoundFilter = object { filters, type }

Combine multiple filters using and or or.

filters: array of ComparisonFilter { key, type, value } or unknown

Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.

Accepts one of the following:
ComparisonFilter = object { key, type, value }

A filter used to compare a specified attribute key to a given value using a defined comparison operation.

key: string

The key to compare against the value.

type: "eq" or "ne" or "gt" or 3 more

Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.

  • eq: equals
  • ne: not equal
  • gt: greater than
  • gte: greater than or equal
  • lt: less than
  • lte: less than or equal
  • in: in
  • nin: not in
Accepts one of the following:
"eq"
"ne"
"gt"
"gte"
"lt"
"lte"
value: string or number or boolean or array of string or number

The value to compare against the attribute key; supports string, number, or boolean types.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember2 = boolean
UnionMember3 = array of string or number
Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember1 = unknown
type: "and" or "or"

Type of operation: and or or.

Accepts one of the following:
"and"
"or"
max_num_results: optional number

The maximum number of results to return. This number should be between 1 and 50 inclusive.

ranking_options: optional object { hybrid_search, ranker, score_threshold }

Ranking options for search.

ranker: optional "auto" or "default-2024-11-15"

The ranker to use for the file search.

Accepts one of the following:
"auto"
"default-2024-11-15"
score_threshold: optional number

The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results.

Computer = object { type }

A tool that controls a virtual computer. Learn more about the computer tool.

type: "computer"

The type of the computer tool. Always computer.

ComputerUsePreview = object { display_height, display_width, environment, type }

A tool that controls a virtual computer. Learn more about the computer tool.

display_height: number

The height of the computer display.

display_width: number

The width of the computer display.

environment: "windows" or "mac" or "linux" or 2 more

The type of computer environment to control.

Accepts one of the following:
"windows"
"mac"
"linux"
"ubuntu"
"browser"
type: "computer_use_preview"

The type of the computer use tool. Always computer_use_preview.

WebSearch = object { type, filters, search_context_size, user_location }

Search the Internet for sources related to the prompt. Learn more about the web search tool.

type: "web_search" or "web_search_2025_08_26"

The type of the web search tool. One of web_search or web_search_2025_08_26.

Accepts one of the following:
"web_search"
"web_search_2025_08_26"
filters: optional object { allowed_domains }

Filters for the search.

allowed_domains: optional array of string

Allowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well.

Example: ["pubmed.ncbi.nlm.nih.gov"]

search_context_size: optional "low" or "medium" or "high"

High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.

Accepts one of the following:
"low"
"medium"
"high"
user_location: optional object { city, country, region, 2 more }

The approximate location of the user.

city: optional string

Free text input for the city of the user, e.g. San Francisco.

country: optional string

The two-letter ISO country code of the user, e.g. US.

region: optional string

Free text input for the region of the user, e.g. California.

timezone: optional string

The IANA timezone of the user, e.g. America/Los_Angeles.

type: optional "approximate"

The type of location approximation. Always approximate.

Mcp = object { server_label, type, allowed_tools, 7 more }

Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.

server_label: string

A label for this MCP server, used to identify it in tool calls.

type: "mcp"

The type of the MCP tool. Always mcp.

allowed_tools: optional array of string or object { read_only, tool_names }

List of allowed tool names or a filter object.

Accepts one of the following:
McpAllowedTools = array of string

A string array of allowed tool names

McpToolFilter = object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

authorization: optional string

An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.

connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 more

Identifier for service connectors, like those available in ChatGPT. One of server_url or connector_id must be provided. Learn more about service connectors here.

Currently supported connector_id values are:

  • Dropbox: connector_dropbox
  • Gmail: connector_gmail
  • Google Calendar: connector_googlecalendar
  • Google Drive: connector_googledrive
  • Microsoft Teams: connector_microsoftteams
  • Outlook Calendar: connector_outlookcalendar
  • Outlook Email: connector_outlookemail
  • SharePoint: connector_sharepoint
Accepts one of the following:
"connector_dropbox"
"connector_gmail"
"connector_googlecalendar"
"connector_googledrive"
"connector_microsoftteams"
"connector_outlookcalendar"
"connector_outlookemail"
"connector_sharepoint"
defer_loading: optional boolean

Whether this MCP tool is deferred and discovered via tool search.

headers: optional map[string]

Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.

require_approval: optional object { always, never } or "always" or "never"

Specify which of the MCP server's tools require approval.

Accepts one of the following:
McpToolApprovalFilter = object { always, never }

Specify which of the MCP server's tools require approval. Can be always, never, or a filter object associated with tools that require approval.

always: optional object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

never: optional object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

McpToolApprovalSetting = "always" or "never"

Specify a single approval policy for all tools. One of always or never. When set to always, all tools will require approval. When set to never, all tools will not require approval.

Accepts one of the following:
"always"
"never"
server_description: optional string

Optional description of the MCP server, used to provide more context.

server_url: optional string

The URL for the MCP server. One of server_url or connector_id must be provided.

CodeInterpreter = object { container, type }

A tool that runs Python code to help generate a response to a prompt.

container: string or object { type, file_ids, memory_limit, network_policy }

The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting.

Accepts one of the following:
UnionMember0 = string

The container ID.

CodeInterpreterToolAuto = object { type, file_ids, memory_limit, network_policy }

Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.

type: "auto"

Always auto.

file_ids: optional array of string

An optional list of uploaded files to make available to your code.

memory_limit: optional "1g" or "4g" or "16g" or "64g"

The memory limit for the code interpreter container.

Accepts one of the following:
"1g"
"4g"
"16g"
"64g"
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets }

Network access policy for the container.

Accepts one of the following:
ContainerNetworkPolicyDisabled = object { type }
type: "disabled"

Disable outbound network access. Always disabled.

ContainerNetworkPolicyAllowlist = object { allowed_domains, type, domain_secrets }
allowed_domains: array of string

A list of allowed domains when type is allowlist.

type: "allowlist"

Allow outbound network access only to specified domains. Always allowlist.

domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value }

Optional domain-scoped secrets for allowlisted domains.

domain: string

The domain associated with the secret.

minLength1
name: string

The name of the secret to inject for the domain.

minLength1
value: string

The secret value to inject for the domain.

maxLength10485760
minLength1
type: "code_interpreter"

The type of the code interpreter tool. Always code_interpreter.

ImageGeneration = object { type, action, background, 9 more }

A tool that generates images using the GPT image models.

type: "image_generation"

The type of the image generation tool. Always image_generation.

action: optional "generate" or "edit" or "auto"

Whether to generate a new image or edit an existing image. Default: auto.

Accepts one of the following:
"generate"
"edit"
"auto"
background: optional "transparent" or "opaque" or "auto"

Background type for the generated image. One of transparent, opaque, or auto. Default: auto.

Accepts one of the following:
"transparent"
"opaque"
"auto"
input_fidelity: optional "high" or "low"

Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.

Accepts one of the following:
"high"
"low"
input_image_mask: optional object { file_id, image_url }

Optional mask for inpainting. Contains image_url (string, optional) and file_id (string, optional).

file_id: optional string

File ID for the mask image.

image_url: optional string

Base64-encoded mask image.

model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"

The image generation model to use. Default: gpt-image-1.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"

The image generation model to use. Default: gpt-image-1.

Accepts one of the following:
"gpt-image-1"
"gpt-image-1-mini"
"gpt-image-1.5"
moderation: optional "auto" or "low"

Moderation level for the generated image. Default: auto.

Accepts one of the following:
"auto"
"low"
output_compression: optional number

Compression level for the output image. Default: 100.

minimum0
maximum100
output_format: optional "png" or "webp" or "jpeg"

The output format of the generated image. One of png, webp, or jpeg. Default: png.

Accepts one of the following:
"png"
"webp"
"jpeg"
partial_images: optional number

Number of partial images to generate in streaming mode, from 0 (default value) to 3.

minimum0
maximum3
quality: optional "low" or "medium" or "high" or "auto"

The quality of the generated image. One of low, medium, high, or auto. Default: auto.

Accepts one of the following:
"low"
"medium"
"high"
"auto"
size: optional "1024x1024" or "1024x1536" or "1536x1024" or "auto"

The size of the generated image. One of 1024x1024, 1024x1536, 1536x1024, or auto. Default: auto.

Accepts one of the following:
"1024x1024"
"1024x1536"
"1536x1024"
"auto"
LocalShell = object { type }

A tool that allows the model to execute shell commands in a local environment.

type: "local_shell"

The type of the local shell tool. Always local_shell.

Shell = object { type, environment }

A tool that allows the model to execute shell commands.

type: "shell"

The type of the shell tool. Always shell.

environment: optional ContainerAuto { type, file_ids, memory_limit, 2 more } or LocalEnvironment { type, skills } or ContainerReference { container_id, type }
Accepts one of the following:
ContainerAuto = object { type, file_ids, memory_limit, 2 more }
type: "container_auto"

Automatically creates a container for this request

file_ids: optional array of string

An optional list of uploaded files to make available to your code.

memory_limit: optional "1g" or "4g" or "16g" or "64g"

The memory limit for the container.

Accepts one of the following:
"1g"
"4g"
"16g"
"64g"
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets }

Network access policy for the container.

Accepts one of the following:
ContainerNetworkPolicyDisabled = object { type }
type: "disabled"

Disable outbound network access. Always disabled.

ContainerNetworkPolicyAllowlist = object { allowed_domains, type, domain_secrets }
allowed_domains: array of string

A list of allowed domains when type is allowlist.

type: "allowlist"

Allow outbound network access only to specified domains. Always allowlist.

domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value }

Optional domain-scoped secrets for allowlisted domains.

domain: string

The domain associated with the secret.

minLength1
name: string

The name of the secret to inject for the domain.

minLength1
value: string

The secret value to inject for the domain.

maxLength10485760
minLength1
skills: optional array of SkillReference { skill_id, type, version } or InlineSkill { description, name, source, type }

An optional list of skills referenced by id or inline data.

Accepts one of the following:
SkillReference = object { skill_id, type, version }
skill_id: string

The ID of the referenced skill.

maxLength64
minLength1
type: "skill_reference"

References a skill created with the /v1/skills endpoint.

version: optional string

Optional skill version. Use a positive integer or 'latest'. Omit for default.

InlineSkill = object { description, name, source, type }
description: string

The description of the skill.

name: string

The name of the skill.

source: InlineSkillSource { data, media_type, type }

Inline skill payload

data: string

Base64-encoded skill zip bundle.

maxLength70254592
minLength1
media_type: "application/zip"

The media type of the inline skill payload. Must be application/zip.

type: "base64"

The type of the inline skill source. Must be base64.

type: "inline"

Defines an inline skill for this request.

LocalEnvironment = object { type, skills }
type: "local"

Use a local computer environment.

skills: optional array of LocalSkill { description, name, path }

An optional list of skills.

description: string

The description of the skill.

name: string

The name of the skill.

path: string

The path to the directory containing the skill.

ContainerReference = object { container_id, type }
container_id: string

The ID of the referenced container.

type: "container_reference"

References a container created with the /v1/containers endpoint

Custom = object { name, type, defer_loading, 2 more }

A custom tool that processes input using a specified format. Learn more about custom tools

name: string

The name of the custom tool, used to identify it in tool calls.

type: "custom"

The type of the custom tool. Always custom.

defer_loading: optional boolean

Whether this tool should be deferred and discovered via tool search.

description: optional string

Optional description of the custom tool, used to provide more context.

format: optional CustomToolInputFormat

The input format for the custom tool. Default is unconstrained text.

Accepts one of the following:
Text = object { type }

Unconstrained free-form text.

type: "text"

Unconstrained text format. Always text.

Grammar = object { definition, syntax, type }

A grammar defined by the user.

definition: string

The grammar definition.

syntax: "lark" or "regex"

The syntax of the grammar definition. One of lark or regex.

Accepts one of the following:
"lark"
"regex"
type: "grammar"

Grammar format. Always grammar.

Namespace = object { description, name, tools, type }

Groups function/custom tools under a shared namespace.

description: string

A description of the namespace shown to the model.

minLength1
name: string

The namespace name used in tool calls (for example, crm).

minLength1
tools: array of object { name, type, description, 2 more } or object { name, type, defer_loading, 2 more }

The function/custom tools available inside this namespace.

Accepts one of the following:
Function = object { name, type, description, 2 more }
name: string
maxLength128
minLength1
type: "function"
description: optional string
parameters: optional unknown
strict: optional boolean
Custom = object { name, type, defer_loading, 2 more }

A custom tool that processes input using a specified format. Learn more about custom tools

name: string

The name of the custom tool, used to identify it in tool calls.

type: "custom"

The type of the custom tool. Always custom.

defer_loading: optional boolean

Whether this tool should be deferred and discovered via tool search.

description: optional string

Optional description of the custom tool, used to provide more context.

format: optional CustomToolInputFormat

The input format for the custom tool. Default is unconstrained text.

Accepts one of the following:
Text = object { type }

Unconstrained free-form text.

type: "text"

Unconstrained text format. Always text.

Grammar = object { definition, syntax, type }

A grammar defined by the user.

definition: string

The grammar definition.

syntax: "lark" or "regex"

The syntax of the grammar definition. One of lark or regex.

Accepts one of the following:
"lark"
"regex"
type: "grammar"

Grammar format. Always grammar.

type: "namespace"

The type of the tool. Always namespace.

ToolSearch = object { type, description, execution, parameters }

Hosted or BYOT tool search configuration for deferred tools.

type: "tool_search"

The type of the tool. Always tool_search.

description: optional string

Description shown to the model for a client-executed tool search tool.

execution: optional "server" or "client"

Whether tool search is executed by the server or by the client.

Accepts one of the following:
"server"
"client"
parameters: optional unknown

Parameter schema for a client-executed tool search tool.

WebSearchPreview = object { type, search_content_types, search_context_size, user_location }

This tool searches the web for relevant results to use in a response. Learn more about the web search tool.

type: "web_search_preview" or "web_search_preview_2025_03_11"

The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.

Accepts one of the following:
"web_search_preview"
"web_search_preview_2025_03_11"
search_content_types: optional array of "text" or "image"
Accepts one of the following:
"text"
"image"
search_context_size: optional "low" or "medium" or "high"

High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.

Accepts one of the following:
"low"
"medium"
"high"
user_location: optional object { type, city, country, 2 more }

The user's location.

type: "approximate"

The type of location approximation. Always approximate.

city: optional string

Free text input for the city of the user, e.g. San Francisco.

country: optional string

The two-letter ISO country code of the user, e.g. US.

region: optional string

Free text input for the region of the user, e.g. California.

timezone: optional string

The IANA timezone of the user, e.g. America/Los_Angeles.

ApplyPatch = object { type }

Allows the assistant to create, delete, or update files using unified diffs.

type: "apply_patch"

The type of the tool. Always apply_patch.

type: "tool_search_output"

The item type. Always tool_search_output.

id: optional string

The unique ID of this tool search output.

call_id: optional string

The unique ID of the tool search call generated by the model.

maxLength64
minLength1
execution: optional "server" or "client"

Whether tool search was executed by the server or by the client.

Accepts one of the following:
"server"
"client"
status: optional "in_progress" or "completed" or "incomplete"

The status of the tool search output.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
Reasoning = object { id, summary, type, 3 more }

A description of the chain of thought used by a reasoning model while generating a response. Be sure to include these items in your input to the Responses API for subsequent turns of a conversation if you are manually managing context.

id: string

The unique identifier of the reasoning content.

summary: array of SummaryTextContent { text, type }

Reasoning summary content.

text: string

A summary of the reasoning output from the model so far.

type: "summary_text"

The type of the object. Always summary_text.

type: "reasoning"

The type of the object. Always reasoning.

content: optional array of object { text, type }

Reasoning text content.

text: string

The reasoning text from the model.

type: "reasoning_text"

The type of the reasoning text. Always reasoning_text.

encrypted_content: optional string

The encrypted content of the reasoning item - populated when a response is generated with reasoning.encrypted_content in the include parameter.

status: optional "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
Compaction = object { encrypted_content, type, id }

A compaction item generated by the v1/responses/compact API.

encrypted_content: string

The encrypted content of the compaction summary.

maxLength10485760
type: "compaction"

The type of the item. Always compaction.

id: optional string

The ID of the compaction item.

ImageGenerationCall = object { id, result, status, type }

An image generation request made by the model.

id: string

The unique ID of the image generation call.

result: string

The generated image encoded in base64.

status: "in_progress" or "completed" or "generating" or "failed"

The status of the image generation call.

Accepts one of the following:
"in_progress"
"completed"
"generating"
"failed"
type: "image_generation_call"

The type of the image generation call. Always image_generation_call.

CodeInterpreterCall = object { id, code, container_id, 3 more }

A tool call to run code.

id: string

The unique ID of the code interpreter tool call.

code: string

The code to run, or null if not available.

container_id: string

The ID of the container used to run the code.

outputs: array of object { logs, type } or object { type, url }

The outputs generated by the code interpreter, such as logs or images. Can be null if no outputs are available.

Accepts one of the following:
Logs = object { logs, type }

The logs output from the code interpreter.

logs: string

The logs output from the code interpreter.

type: "logs"

The type of the output. Always logs.

Image = object { type, url }

The image output from the code interpreter.

type: "image"

The type of the output. Always image.

url: string

The URL of the image output from the code interpreter.

status: "in_progress" or "completed" or "incomplete" or 2 more

The status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
"interpreting"
"failed"
type: "code_interpreter_call"

The type of the code interpreter tool call. Always code_interpreter_call.

LocalShellCall = object { id, action, call_id, 2 more }

A tool call to run a command on the local shell.

id: string

The unique ID of the local shell call.

action: object { command, env, type, 3 more }

Execute a shell command on the server.

command: array of string

The command to run.

env: map[string]

Environment variables to set for the command.

type: "exec"

The type of the local shell action. Always exec.

timeout_ms: optional number

Optional timeout in milliseconds for the command.

user: optional string

Optional user to run the command as.

working_directory: optional string

Optional working directory to run the command in.

call_id: string

The unique ID of the local shell tool call generated by the model.

status: "in_progress" or "completed" or "incomplete"

The status of the local shell call.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: "local_shell_call"

The type of the local shell call. Always local_shell_call.

LocalShellCallOutput = object { id, output, type, status }

The output of a local shell tool call.

id: string

The unique ID of the local shell tool call generated by the model.

output: string

A JSON string of the output of the local shell tool call.

type: "local_shell_call_output"

The type of the local shell tool call output. Always local_shell_call_output.

status: optional "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ShellCall = object { action, call_id, type, 3 more }

A tool representing a request to execute one or more shell commands.

action: object { commands, max_output_length, timeout_ms }

The shell commands and limits that describe how to run the tool call.

commands: array of string

Ordered shell commands for the execution environment to run.

max_output_length: optional number

Maximum number of UTF-8 characters to capture from combined stdout and stderr output.

timeout_ms: optional number

Maximum wall-clock time in milliseconds to allow the shell commands to run.

call_id: string

The unique ID of the shell tool call generated by the model.

maxLength64
minLength1
type: "shell_call"

The type of the item. Always shell_call.

id: optional string

The unique ID of the shell tool call. Populated when this item is returned via API.

environment: optional LocalEnvironment { type, skills } or ContainerReference { container_id, type }

The environment to execute the shell commands in.

Accepts one of the following:
LocalEnvironment = object { type, skills }
type: "local"

Use a local computer environment.

skills: optional array of LocalSkill { description, name, path }

An optional list of skills.

description: string

The description of the skill.

name: string

The name of the skill.

path: string

The path to the directory containing the skill.

ContainerReference = object { container_id, type }
container_id: string

The ID of the referenced container.

type: "container_reference"

References a container created with the /v1/containers endpoint

status: optional "in_progress" or "completed" or "incomplete"

The status of the shell call. One of in_progress, completed, or incomplete.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ShellCallOutput = object { call_id, output, type, 3 more }

The streamed output items emitted by a shell tool call.

call_id: string

The unique ID of the shell tool call generated by the model.

maxLength64
minLength1
output: array of ResponseFunctionShellCallOutputContent { outcome, stderr, stdout }

Captured chunks of stdout and stderr output, along with their associated outcomes.

outcome: object { type } or object { exit_code, type }

The exit or timeout outcome associated with this shell call.

Accepts one of the following:
Timeout = object { type }

Indicates that the shell call exceeded its configured time limit.

type: "timeout"

The outcome type. Always timeout.

Exit = object { exit_code, type }

Indicates that the shell commands finished and returned an exit code.

exit_code: number

The exit code returned by the shell process.

type: "exit"

The outcome type. Always exit.

stderr: string

Captured stderr output for the shell call.

maxLength10485760
stdout: string

Captured stdout output for the shell call.

maxLength10485760
type: "shell_call_output"

The type of the item. Always shell_call_output.

id: optional string

The unique ID of the shell tool call output. Populated when this item is returned via API.

max_output_length: optional number

The maximum number of UTF-8 characters captured for this shell call's combined output.

status: optional "in_progress" or "completed" or "incomplete"

The status of the shell call output.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ApplyPatchCall = object { call_id, operation, status, 2 more }

A tool call representing a request to create, delete, or update files using diff patches.

call_id: string

The unique ID of the apply patch tool call generated by the model.

maxLength64
minLength1
operation: object { diff, path, type } or object { path, type } or object { diff, path, type }

The specific create, delete, or update instruction for the apply_patch tool call.

Accepts one of the following:
CreateFile = object { diff, path, type }

Instruction for creating a new file via the apply_patch tool.

diff: string

Unified diff content to apply when creating the file.

maxLength10485760
path: string

Path of the file to create relative to the workspace root.

minLength1
type: "create_file"

The operation type. Always create_file.

DeleteFile = object { path, type }

Instruction for deleting an existing file via the apply_patch tool.

path: string

Path of the file to delete relative to the workspace root.

minLength1
type: "delete_file"

The operation type. Always delete_file.

UpdateFile = object { diff, path, type }

Instruction for updating an existing file via the apply_patch tool.

diff: string

Unified diff content to apply to the existing file.

maxLength10485760
path: string

Path of the file to update relative to the workspace root.

minLength1
type: "update_file"

The operation type. Always update_file.

status: "in_progress" or "completed"

The status of the apply patch tool call. One of in_progress or completed.

Accepts one of the following:
"in_progress"
"completed"
type: "apply_patch_call"

The type of the item. Always apply_patch_call.

id: optional string

The unique ID of the apply patch tool call. Populated when this item is returned via API.

ApplyPatchCallOutput = object { call_id, status, type, 2 more }

The streamed output emitted by an apply patch tool call.

call_id: string

The unique ID of the apply patch tool call generated by the model.

maxLength64
minLength1
status: "completed" or "failed"

The status of the apply patch tool call output. One of completed or failed.

Accepts one of the following:
"completed"
"failed"
type: "apply_patch_call_output"

The type of the item. Always apply_patch_call_output.

id: optional string

The unique ID of the apply patch tool call output. Populated when this item is returned via API.

output: optional string

Optional human-readable log text from the apply patch tool (e.g., patch results or errors).

maxLength10485760
McpListTools = object { id, server_label, tools, 2 more }

A list of tools available on an MCP server.

id: string

The unique ID of the list.

server_label: string

The label of the MCP server.

tools: array of object { input_schema, name, annotations, description }

The tools available on the server.

input_schema: unknown

The JSON schema describing the tool's input.

name: string

The name of the tool.

annotations: optional unknown

Additional annotations about the tool.

description: optional string

The description of the tool.

type: "mcp_list_tools"

The type of the item. Always mcp_list_tools.

error: optional string

Error message if the server could not list tools.

McpApprovalRequest = object { id, arguments, name, 2 more }

A request for human approval of a tool invocation.

id: string

The unique ID of the approval request.

arguments: string

A JSON string of arguments for the tool.

name: string

The name of the tool to run.

server_label: string

The label of the MCP server making the request.

type: "mcp_approval_request"

The type of the item. Always mcp_approval_request.

McpApprovalResponse = object { approval_request_id, approve, type, 2 more }

A response to an MCP approval request.

approval_request_id: string

The ID of the approval request being answered.

approve: boolean

Whether the request was approved.

type: "mcp_approval_response"

The type of the item. Always mcp_approval_response.

id: optional string

The unique ID of the approval response

reason: optional string

Optional reason for the decision.

McpCall = object { id, arguments, name, 6 more }

An invocation of a tool on an MCP server.

id: string

The unique ID of the tool call.

arguments: string

A JSON string of the arguments passed to the tool.

name: string

The name of the tool that was run.

server_label: string

The label of the MCP server running the tool.

type: "mcp_call"

The type of the item. Always mcp_call.

approval_request_id: optional string

Unique identifier for the MCP tool call approval request. Include this value in a subsequent mcp_approval_response input to approve or reject the corresponding tool call.

error: optional string

The error from the tool call, if any.

output: optional string

The output from the tool call.

status: optional "in_progress" or "completed" or "incomplete" or 2 more

The status of the tool call. One of in_progress, completed, incomplete, calling, or failed.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
"calling"
"failed"
CustomToolCallOutput = object { call_id, output, type, id }

The output of a custom tool call from your code, being sent back to the model.

call_id: string

The call ID, used to map this custom tool call output to a custom tool call.

output: string or array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more }

The output from the custom tool call generated by your code. Can be a string or an list of output content.

Accepts one of the following:
StringOutput = string

A string of the output of the custom tool call.

OutputContentList = array of ResponseInputText { text, type } or ResponseInputImage { detail, type, file_id, image_url } or ResponseInputFile { type, detail, file_data, 3 more }

Text, image, or file output of the custom tool call.

Accepts one of the following:
ResponseInputText = object { text, type }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

ResponseInputImage = object { detail, type, file_id, image_url }

An image input to the model. Learn about image inputs.

detail: "low" or "high" or "auto" or "original"

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id: optional string

The ID of the file to be sent to the model.

image_url: optional string

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

ResponseInputFile = object { type, detail, file_data, 3 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail: optional "low" or "high"

The detail level of the file to be sent to the model. One of high or low. Defaults to high.

Accepts one of the following:
"low"
"high"
file_data: optional string

The content of the file to be sent to the model.

file_id: optional string

The ID of the file to be sent to the model.

file_url: optional string

The URL of the file to be sent to the model.

filename: optional string

The name of the file to be sent to the model.

type: "custom_tool_call_output"

The type of the custom tool call output. Always custom_tool_call_output.

id: optional string

The unique ID of the custom tool call output in the OpenAI platform.

CustomToolCall = object { call_id, input, name, 3 more }

A call to a custom tool created by the model.

call_id: string

An identifier used to map this custom tool call to a tool call output.

input: string

The input for the custom tool call generated by the model.

name: string

The name of the custom tool being called.

type: "custom_tool_call"

The type of the custom tool call. Always custom_tool_call.

id: optional string

The unique ID of the custom tool call in the OpenAI platform.

namespace: optional string

The namespace of the custom tool being called.

ItemReference = object { id, type }

An internal identifier for an item to reference.

id: string

The ID of the item to reference.

type: optional "item_reference"

The type of item to reference. Always item_reference.

instructions: optional string

A system (or developer) message inserted into the model's context. When used along with previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses.

previous_response_id: optional string

The unique ID of the previous response to the model. Use this to create multi-turn conversations. Learn more about conversation state. Cannot be used in conjunction with conversation.

prompt_cache_key: optional string

A key to use when reading from or writing to the prompt cache.

maxLength64
ReturnsExpand Collapse
CompactedResponse = object { id, created_at, object, 2 more }
id: string

The unique identifier for the compacted response.

created_at: number

Unix timestamp (in seconds) when the compacted conversation was created.

object: "response.compaction"

The object type. Always response.compaction.

output: array of Message { id, content, role, 2 more } or object { arguments, call_id, name, 4 more } or object { id, arguments, call_id, 4 more } or 22 more

The compacted list of output items.

Accepts one of the following:
Message = object { id, content, role, 2 more }

A message to or from the model.

id: string

The unique ID of the message.

content: array of ResponseInputText { text, type } or ResponseOutputText { annotations, logprobs, text, type } or TextContent { text, type } or 6 more

The content of the message

Accepts one of the following:
ResponseInputText = object { text, type }

A text input to the model.

text: string

The text input to the model.

type: "input_text"

The type of the input item. Always input_text.

ResponseOutputText = object { annotations, logprobs, text, type }

A text output from the model.

annotations: array of object { file_id, filename, index, type } or object { end_index, start_index, title, 2 more } or object { container_id, end_index, file_id, 3 more } or object { file_id, index, type }

The annotations of the text output.

Accepts one of the following:
FileCitation = object { file_id, filename, index, type }

A citation to a file.

file_id: string

The ID of the file.

filename: string

The filename of the file cited.

index: number

The index of the file in the list of files.

type: "file_citation"

The type of the file citation. Always file_citation.

URLCitation = object { end_index, start_index, title, 2 more }

A citation for a web resource used to generate a model response.

end_index: number

The index of the last character of the URL citation in the message.

start_index: number

The index of the first character of the URL citation in the message.

title: string

The title of the web resource.

type: "url_citation"

The type of the URL citation. Always url_citation.

url: string

The URL of the web resource.

ContainerFileCitation = object { container_id, end_index, file_id, 3 more }

A citation for a container file used to generate a model response.

container_id: string

The ID of the container file.

end_index: number

The index of the last character of the container file citation in the message.

file_id: string

The ID of the file.

filename: string

The filename of the container file cited.

start_index: number

The index of the first character of the container file citation in the message.

type: "container_file_citation"

The type of the container file citation. Always container_file_citation.

FilePath = object { file_id, index, type }

A path to a file.

file_id: string

The ID of the file.

index: number

The index of the file in the list of files.

type: "file_path"

The type of the file path. Always file_path.

logprobs: array of object { token, bytes, logprob, top_logprobs }
token: string
bytes: array of number
logprob: number
top_logprobs: array of object { token, bytes, logprob }
token: string
bytes: array of number
logprob: number
text: string

The text output from the model.

type: "output_text"

The type of the output text. Always output_text.

TextContent = object { text, type }

A text content.

text: string
type: "text"
SummaryTextContent = object { text, type }

A summary text from the model.

text: string

A summary of the reasoning output from the model so far.

type: "summary_text"

The type of the object. Always summary_text.

ReasoningText = object { text, type }

Reasoning text from the model.

text: string

The reasoning text from the model.

type: "reasoning_text"

The type of the reasoning text. Always reasoning_text.

ResponseOutputRefusal = object { refusal, type }

A refusal from the model.

refusal: string

The refusal explanation from the model.

type: "refusal"

The type of the refusal. Always refusal.

ResponseInputImage = object { detail, type, file_id, image_url }

An image input to the model. Learn about image inputs.

detail: "low" or "high" or "auto" or "original"

The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
type: "input_image"

The type of the input item. Always input_image.

file_id: optional string

The ID of the file to be sent to the model.

image_url: optional string

The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.

ComputerScreenshotContent = object { detail, file_id, image_url, type }

A screenshot of a computer.

detail: "low" or "high" or "auto" or "original"

The detail level of the screenshot image to be sent to the model. One of high, low, auto, or original. Defaults to auto.

Accepts one of the following:
"low"
"high"
"auto"
"original"
file_id: string

The identifier of an uploaded file that contains the screenshot.

image_url: string

The URL of the screenshot image.

type: "computer_screenshot"

Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.

ResponseInputFile = object { type, detail, file_data, 3 more }

A file input to the model.

type: "input_file"

The type of the input item. Always input_file.

detail: optional "low" or "high"

The detail level of the file to be sent to the model. One of high or low. Defaults to high.

Accepts one of the following:
"low"
"high"
file_data: optional string

The content of the file to be sent to the model.

file_id: optional string

The ID of the file to be sent to the model.

file_url: optional string

The URL of the file to be sent to the model.

filename: optional string

The name of the file to be sent to the model.

role: "unknown" or "user" or "assistant" or 5 more

The role of the message. One of unknown, user, assistant, system, critic, discriminator, developer, or tool.

Accepts one of the following:
"unknown"
"user"
"assistant"
"system"
"critic"
"discriminator"
"developer"
"tool"
status: "in_progress" or "completed" or "incomplete"

The status of item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: "message"

The type of the message. Always set to message.

FunctionCall = object { arguments, call_id, name, 4 more }

A tool call to run a function. See the function calling guide for more information.

arguments: string

A JSON string of the arguments to pass to the function.

call_id: string

The unique ID of the function tool call generated by the model.

name: string

The name of the function to run.

type: "function_call"

The type of the function tool call. Always function_call.

id: optional string

The unique ID of the function tool call.

namespace: optional string

The namespace of the function to run.

status: optional "in_progress" or "completed" or "incomplete"

The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
ToolSearchCall = object { id, arguments, call_id, 4 more }
id: string

The unique ID of the tool search call item.

arguments: unknown

Arguments used for the tool search call.

call_id: string

The unique ID of the tool search call generated by the model.

execution: "server" or "client"

Whether tool search was executed by the server or by the client.

Accepts one of the following:
"server"
"client"
status: "in_progress" or "completed" or "incomplete"

The status of the tool search call item that was recorded.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
type: "tool_search_call"

The type of the item. Always tool_search_call.

created_by: optional string

The identifier of the actor that created the item.

ToolSearchOutput = object { id, call_id, execution, 4 more }
id: string

The unique ID of the tool search output item.

call_id: string

The unique ID of the tool search call generated by the model.

execution: "server" or "client"

Whether tool search was executed by the server or by the client.

Accepts one of the following:
"server"
"client"
status: "in_progress" or "completed" or "incomplete"

The status of the tool search output item that was recorded.

Accepts one of the following:
"in_progress"
"completed"
"incomplete"
tools: array of object { name, parameters, strict, 3 more } or object { type, vector_store_ids, filters, 2 more } or object { type } or 12 more

The loaded tool definitions returned by tool search.

Accepts one of the following:
Function = object { name, parameters, strict, 3 more }

Defines a function in your own code the model can choose to call. Learn more about function calling.

name: string

The name of the function to call.

parameters: map[unknown]

A JSON schema object describing the parameters of the function.

strict: boolean

Whether to enforce strict parameter validation. Default true.

type: "function"

The type of the function tool. Always function.

defer_loading: optional boolean

Whether this function is deferred and loaded via tool search.

description: optional string

A description of the function. Used by the model to determine whether or not to call the function.

FileSearch = object { type, vector_store_ids, filters, 2 more }

A tool that searches for relevant content from uploaded files. Learn more about the file search tool.

type: "file_search"

The type of the file search tool. Always file_search.

vector_store_ids: array of string

The IDs of the vector stores to search.

filters: optional ComparisonFilter { key, type, value } or CompoundFilter { filters, type }

A filter to apply.

Accepts one of the following:
ComparisonFilter = object { key, type, value }

A filter used to compare a specified attribute key to a given value using a defined comparison operation.

key: string

The key to compare against the value.

type: "eq" or "ne" or "gt" or 3 more

Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.

  • eq: equals
  • ne: not equal
  • gt: greater than
  • gte: greater than or equal
  • lt: less than
  • lte: less than or equal
  • in: in
  • nin: not in
Accepts one of the following:
"eq"
"ne"
"gt"
"gte"
"lt"
"lte"
value: string or number or boolean or array of string or number

The value to compare against the attribute key; supports string, number, or boolean types.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember2 = boolean
UnionMember3 = array of string or number
Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
CompoundFilter = object { filters, type }

Combine multiple filters using and or or.

filters: array of ComparisonFilter { key, type, value } or unknown

Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.

Accepts one of the following:
ComparisonFilter = object { key, type, value }

A filter used to compare a specified attribute key to a given value using a defined comparison operation.

key: string

The key to compare against the value.

type: "eq" or "ne" or "gt" or 3 more

Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.

  • eq: equals
  • ne: not equal
  • gt: greater than
  • gte: greater than or equal
  • lt: less than
  • lte: less than or equal
  • in: in
  • nin: not in
Accepts one of the following:
"eq"
"ne"
"gt"
"gte"
"lt"
"lte"
value: string or number or boolean or array of string or number

The value to compare against the attribute key; supports string, number, or boolean types.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember2 = boolean
UnionMember3 = array of string or number
Accepts one of the following:
UnionMember0 = string
UnionMember1 = number
UnionMember1 = unknown
type: "and" or "or"

Type of operation: and or or.

Accepts one of the following:
"and"
"or"
max_num_results: optional number

The maximum number of results to return. This number should be between 1 and 50 inclusive.

ranking_options: optional object { hybrid_search, ranker, score_threshold }

Ranking options for search.

ranker: optional "auto" or "default-2024-11-15"

The ranker to use for the file search.

Accepts one of the following:
"auto"
"default-2024-11-15"
score_threshold: optional number

The score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results.

Computer = object { type }

A tool that controls a virtual computer. Learn more about the computer tool.

type: "computer"

The type of the computer tool. Always computer.

ComputerUsePreview = object { display_height, display_width, environment, type }

A tool that controls a virtual computer. Learn more about the computer tool.

display_height: number

The height of the computer display.

display_width: number

The width of the computer display.

environment: "windows" or "mac" or "linux" or 2 more

The type of computer environment to control.

Accepts one of the following:
"windows"
"mac"
"linux"
"ubuntu"
"browser"
type: "computer_use_preview"

The type of the computer use tool. Always computer_use_preview.

WebSearch = object { type, filters, search_context_size, user_location }

Search the Internet for sources related to the prompt. Learn more about the web search tool.

type: "web_search" or "web_search_2025_08_26"

The type of the web search tool. One of web_search or web_search_2025_08_26.

Accepts one of the following:
"web_search"
"web_search_2025_08_26"
filters: optional object { allowed_domains }

Filters for the search.

allowed_domains: optional array of string

Allowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well.

Example: ["pubmed.ncbi.nlm.nih.gov"]

search_context_size: optional "low" or "medium" or "high"

High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.

Accepts one of the following:
"low"
"medium"
"high"
user_location: optional object { city, country, region, 2 more }

The approximate location of the user.

city: optional string

Free text input for the city of the user, e.g. San Francisco.

country: optional string

The two-letter ISO country code of the user, e.g. US.

region: optional string

Free text input for the region of the user, e.g. California.

timezone: optional string

The IANA timezone of the user, e.g. America/Los_Angeles.

type: optional "approximate"

The type of location approximation. Always approximate.

Mcp = object { server_label, type, allowed_tools, 7 more }

Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.

server_label: string

A label for this MCP server, used to identify it in tool calls.

type: "mcp"

The type of the MCP tool. Always mcp.

allowed_tools: optional array of string or object { read_only, tool_names }

List of allowed tool names or a filter object.

Accepts one of the following:
McpAllowedTools = array of string

A string array of allowed tool names

McpToolFilter = object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

authorization: optional string

An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.

connector_id: optional "connector_dropbox" or "connector_gmail" or "connector_googlecalendar" or 5 more

Identifier for service connectors, like those available in ChatGPT. One of server_url or connector_id must be provided. Learn more about service connectors here.

Currently supported connector_id values are:

  • Dropbox: connector_dropbox
  • Gmail: connector_gmail
  • Google Calendar: connector_googlecalendar
  • Google Drive: connector_googledrive
  • Microsoft Teams: connector_microsoftteams
  • Outlook Calendar: connector_outlookcalendar
  • Outlook Email: connector_outlookemail
  • SharePoint: connector_sharepoint
Accepts one of the following:
"connector_dropbox"
"connector_gmail"
"connector_googlecalendar"
"connector_googledrive"
"connector_microsoftteams"
"connector_outlookcalendar"
"connector_outlookemail"
"connector_sharepoint"
defer_loading: optional boolean

Whether this MCP tool is deferred and discovered via tool search.

headers: optional map[string]

Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.

require_approval: optional object { always, never } or "always" or "never"

Specify which of the MCP server's tools require approval.

Accepts one of the following:
McpToolApprovalFilter = object { always, never }

Specify which of the MCP server's tools require approval. Can be always, never, or a filter object associated with tools that require approval.

always: optional object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

never: optional object { read_only, tool_names }

A filter object to specify which tools are allowed.

read_only: optional boolean

Indicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with readOnlyHint, it will match this filter.

tool_names: optional array of string

List of allowed tool names.

McpToolApprovalSetting = "always" or "never"

Specify a single approval policy for all tools. One of always or never. When set to always, all tools will require approval. When set to never, all tools will not require approval.

Accepts one of the following:
"always"
"never"
server_description: optional string

Optional description of the MCP server, used to provide more context.

server_url: optional string

The URL for the MCP server. One of server_url or connector_id must be provided.

CodeInterpreter = object { container, type }

A tool that runs Python code to help generate a response to a prompt.

container: string or object { type, file_ids, memory_limit, network_policy }

The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional memory_limit setting.

Accepts one of the following:
UnionMember0 = string

The container ID.

CodeInterpreterToolAuto = object { type, file_ids, memory_limit, network_policy }

Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.

type: "auto"

Always auto.

file_ids: optional array of string

An optional list of uploaded files to make available to your code.

memory_limit: optional "1g" or "4g" or "16g" or "64g"

The memory limit for the code interpreter container.

Accepts one of the following:
"1g"
"4g"
"16g"
"64g"
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets }

Network access policy for the container.

Accepts one of the following:
ContainerNetworkPolicyDisabled = object { type }
type: "disabled"

Disable outbound network access. Always disabled.

ContainerNetworkPolicyAllowlist = object { allowed_domains, type, domain_secrets }
allowed_domains: array of string

A list of allowed domains when type is allowlist.

type: "allowlist"

Allow outbound network access only to specified domains. Always allowlist.

domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value }

Optional domain-scoped secrets for allowlisted domains.

domain: string

The domain associated with the secret.

minLength1
name: string

The name of the secret to inject for the domain.

minLength1
value: string

The secret value to inject for the domain.

maxLength10485760
minLength1
type: "code_interpreter"

The type of the code interpreter tool. Always code_interpreter.

ImageGeneration = object { type, action, background, 9 more }

A tool that generates images using the GPT image models.

type: "image_generation"

The type of the image generation tool. Always image_generation.

action: optional "generate" or "edit" or "auto"

Whether to generate a new image or edit an existing image. Default: auto.

Accepts one of the following:
"generate"
"edit"
"auto"
background: optional "transparent" or "opaque" or "auto"

Background type for the generated image. One of transparent, opaque, or auto. Default: auto.

Accepts one of the following:
"transparent"
"opaque"
"auto"
input_fidelity: optional "high" or "low"

Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.

Accepts one of the following:
"high"
"low"
input_image_mask: optional object { file_id, image_url }

Optional mask for inpainting. Contains image_url (string, optional) and file_id (string, optional).

file_id: optional string

File ID for the mask image.

image_url: optional string

Base64-encoded mask image.

model: optional string or "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"

The image generation model to use. Default: gpt-image-1.

Accepts one of the following:
UnionMember0 = string
UnionMember1 = "gpt-image-1" or "gpt-image-1-mini" or "gpt-image-1.5"

The image generation model to use. Default: gpt-image-1.

Accepts one of the following:
"gpt-image-1"
"gpt-image-1-mini"
"gpt-image-1.5"
moderation: optional "auto" or "low"

Moderation level for the generated image. Default: auto.

Accepts one of the following:
"auto"
"low"
output_compression: optional number

Compression level for the output image. Default: 100.

minimum0
maximum100
output_format: optional "png" or "webp" or "jpeg"

The output format of the generated image. One of png, webp, or jpeg. Default: png.

Accepts one of the following:
"png"
"webp"
"jpeg"
partial_images: optional number

Number of partial images to generate in streaming mode, from 0 (default value) to 3.

minimum0
maximum3
quality: optional "low" or "medium" or "high" or "auto"

The quality of the generated image. One of low, medium, high, or auto. Default: auto.

Accepts one of the following:
"low"
"medium"
"high"
"auto"
size: optional "1024x1024" or "1024x1536" or "1536x1024" or "auto"

The size of the generated image. One of 1024x1024, 1024x1536, 1536x1024, or auto. Default: auto.

Accepts one of the following:
"1024x1024"
"1024x1536"
"1536x1024"
"auto"
LocalShell = object { type }

A tool that allows the model to execute shell commands in a local environment.

type: "local_shell"

The type of the local shell tool. Always local_shell.

Shell = object { type, environment }

A tool that allows the model to execute shell commands.

type: "shell"

The type of the shell tool. Always shell.

environment: optional ContainerAuto { type, file_ids, memory_limit, 2 more } or LocalEnvironment { type, skills } or ContainerReference { container_id, type }
Accepts one of the following:
ContainerAuto = object { type, file_ids, memory_limit, 2 more }
type: "container_auto"

Automatically creates a container for this request

file_ids: optional array of string

An optional list of uploaded files to make available to your code.

memory_limit: optional "1g" or "4g" or "16g" or "64g"

The memory limit for the container.

Accepts one of the following:
"1g"
"4g"
"16g"
"64g"
network_policy: optional ContainerNetworkPolicyDisabled { type } or ContainerNetworkPolicyAllowlist { allowed_domains, type, domain_secrets }

Network access policy for the container.

Accepts one of the following:
ContainerNetworkPolicyDisabled = object { type }
type: "disabled"

Disable outbound network access. Always disabled.

ContainerNetworkPolicyAllowlist = object { allowed_domains, type, domain_secrets }
allowed_domains: array of string

A list of allowed domains when type is allowlist.

type: "allowlist"

Allow outbound network access only to specified domains. Always allowlist.

domain_secrets: optional array of ContainerNetworkPolicyDomainSecret { domain, name, value }

Optional domain-scoped secrets for allowlisted domains.

domain: string

The domain associated with the secret.

minLength1
name: string

The name of the secret to inject for the domain.

minLength1
value: string

The secret value to inject for the domain.

maxLength10485760
minLength1
skills: optional array of SkillReference { skill_id, type, version } or InlineSkill { description, name, source, type }

An optional list of skills referenced by id or inline data.

Accepts one of the following:
SkillReference = object { skill_id, type, version }
skill_id: string

The ID of the referenced skill.

maxLength64
minLength1
type: "skill_reference"

References a skill created with the /v1/skills endpoint.

version: optional string

Optional skill version. Use a positive integer or 'latest'. Omit for default.

InlineSkill = object { description, name, source, type }
description: string

The description of the skill.

name: string

The name of the skill.

source: InlineSkillSource { data, media_type, type }

Inline skill payload

data: string

Base64-encoded skill zip bundle.

maxLength70254592
minLength1
media_type: "application/zip"

The media type of the inline skill payload. Must be application/zip.

type: "base64"

The type of the inline skill source. Must be base64.

type: "inline"

Defines an inline skill for this request.

LocalEnvironment = object { type, skills }
type: "local"

Use a local computer environment.

skills: optional array of LocalSkill { description, name, path }

An optional list of skills.

description: string

The description of the skill.

name: string

The name of the skill.

path: string

The path to the directory containing the skill.

ContainerReference = object { container_id, type }
container_id: string

The ID of the referenced container.

type: "container_reference"

References a container created with the /v1/containers endpoint

Custom = object { name, type, defer_loading, 2 more }

A custom tool that processes input using a specified format. Learn more about custom tools

name: string

The name of the custom tool, used to identify it in tool calls.

type: "custom"

The type of the custom tool. Always custom.

defer_loading: optional boolean

Whether this tool should be deferred and discovered via tool search.

description: optional string

Optional description of the custom tool, used to provide more context.

format: optional CustomToolInputFormat

The input format for the custom tool. Default is unconstrained text.

Accepts one of the following:
Text = object { type }

Unconstrained free-form text.

type: "text"

Unconstrained text format. Always text.

Grammar = object { definition, syntax, type }

A grammar defined by the user.

definition: string

The grammar definition.

syntax: "lark" or "regex"

The syntax of the grammar definition. One of lark or regex.

Accepts one of the following:
"lark"
"regex"
type: "grammar"

Grammar format. Always grammar.

Namespace = object { description, name, tools, type }

Groups function/custom tools under a shared namespace.

description: string

A description of the namespace shown to the model.

minLength1
name: string

The namespace name used in tool calls (for example, crm).

minLength1
tools: array of object { name, type, description, 2 more } or object { name, type, defer_loading, 2 more }

The function/custom tools available inside this namespace.

Accepts one of the following:
Function = object { name, type, description, 2 more }
name: string
maxLength128
minLength1
type: "function"
description: optional string
parameters: optional unknown
strict: optional boolean
Custom = object { name, type, defer_loading, 2 more }

A custom tool that processes input using a specified format. Learn more about custom tools

name: string

The name of the custom tool, used to identify it in tool calls.

type: "custom"

The type of the custom tool. Always custom.

defer_loading: optional boolean

Whether this tool should be deferred and discovered via tool search.

description: optional string

Optional description of the custom tool, used to provide more context.

format: optional CustomToolInputFormat

The input format for the custom tool. Default is unconstrained text.

Accepts one of the following:
Text = object { type }

Unconstrained free-form text.

type: "text"

Unconstrained text format. Always text.

Grammar = object { definition, syntax, type }

A grammar defined by the user.

definition: string

The grammar definition.

syntax: "lark" or "regex"

The syntax of the grammar definition. One of lark or regex.

Accepts one of the following:
"lark"
"regex"
type: "grammar"

Grammar format. Always grammar.

type: "namespace"

The type of the tool. Always namespace.

ToolSearch = object { type, description, execution, parameters }

Hosted or BYOT tool search configuration for deferred tools.

type: "tool_search"

The type of the tool. Always tool_search.

description: optional string

Description shown to the model for a client-executed tool search tool.

execution: optional "server" or "client"

Whether tool search is executed by the server or by the client.

Accepts one of the following:
"server"
"client"
parameters: optional unknown

Parameter schema for a client-executed tool search tool.

WebSearchPreview = object { type, search_content_types, search_context_size, user_location }

This tool searches the web for relevant results to use in a response. Learn more about the web search tool.

type: "web_search_preview" or "web_search_preview_2025_03_11"

The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.

Accepts one of the following:
"web_search_preview"
"web_search_preview_2025_03_11"
search_content_types: optional array of "text" or "image"
Accepts one of the following:
"text"
"image"
search_context_size: optional "low" or "medium" or "high"

High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.

Accepts one of the following:
"low"
"medium"
"high"
user_location: optional object { type, city, country, 2 more }

The user's location.

type: "approximate"

The type of location approximation. Always approximate.

city: optional string

Free text input for the city of the user, e.g. San Francisco.

country: optional string

The two-letter ISO country code of the user, e.g. US.

region: optional string

Free text input for the region of the user, e.g. California.

timezone: optional string

[...]
